// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "SceneItemComponents.hpp"
#include "scene/SceneItem.hpp"
#include "assert/assert.hpp"

using namespace Dawn;

SceneItemComponents::SceneItemComponents() {

}

void SceneItemComponents::removeComponent(
  const std::shared_ptr<SceneComponent> component
) {
  auto it = std::find(components.begin(), components.end(), component);
  if(it == components.end()) return; //Not found?
  it->get()->dispose();
  components.erase(it);
}

void SceneItemComponents::sceneItemComponentsReferenceSelf(
  std::shared_ptr<SceneComponent> component
) {
  assertNotNull(component, "Component cannot be NULL");
  auto self = (SceneItem *)this;
  component->item = self->shared_from_this();
}

SceneItemComponents::~SceneItemComponents() {

}