// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/shader/IShaderData.hpp"
#include "dawnopengl.hpp"

namespace Dawn {
  class ShaderData : public IShaderData {
    private:
      GLuint buffer = -1;

    public:
      std::unordered_map<size_t, uint8_t> textureIndices;
      std::unordered_map<uint8_t, std::shared_ptr<Texture>> textureBindings;

      ShaderData(
        const std::shared_ptr<ShaderStructure> &structure
      );

      void upload() override;
      void bind() override;
      
      ~ShaderData() override;
  };
}