// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/shader/IShaderProgram.hpp"
#include "dawnopengl.hpp"
#include "display/Texture.hpp"
#include "slang.h"

using namespace slang;

namespace Dawn {
  class ShaderData;
  
  class ShaderProgram :
    public IShaderProgram,
    public std::enable_shared_from_this<ShaderProgram>
  {
    private:
      GLuint id = -1;
      std::shared_ptr<ShaderData> data;
      std::shared_ptr<Texture> testTexture;

    public:
      void init(
        IModule *module,
        Slang::ComPtr<ISession> session
      ) override;

      void bind() override;

      ~ShaderProgram() override;
  };
}